
package client

import org.scalajs.dom
import scala.concurrent.Future
import scala.scalajs.js.annotation._
import scala.scalajs.concurrent.JSExecutionContext.Implicits.runNow
import scaladget.api.{BootstrapTags => bs}
import scaladget.stylesheet.all._
import scalatags.JsDom.all._
import shared.Api
import autowire._


@JSExportTopLevel(name = "client.Gate")
@JSExportAll
object Gate {

  def run(): Unit = {

    val loginDiv = div(
      bs.input()(placeholder := "Login", color := "red"),
      bs.input()(placeholder := "Password")
    )

    val logButton = button(btn_primary, "Run", onclick := {()=> Post[Api].login.call().foreach {l=>
      println("Finished")
    }})


    dom.document.body.appendChild(
      div(
       // loginDiv,
        logButton
      ).render
    )
  }
}

object Post extends autowire.Client[String, upickle.default.Reader, upickle.default.Writer] {

  override def doCall(req: Request): Future[String] = {
    val url = req.path.mkString("/")
    dom.ext.Ajax.post(
      url = "http://localhost:8080/" + url,
      data = upickle.default.write(req.args)
    ).map {
      _.responseText
    }
  }

  def read[Result: upickle.default.Reader](p: String) = upickle.default.read[Result](p)

  def write[Result: upickle.default.Writer](r: Result) = upickle.default.write(r)
}
