package server

import java.net.URI
import javax.servlet.ServletContext

import com.mongodb.casbah.MongoClient
import com.mongodb.{MongoCredential, ServerAddress}
import org.eclipse.jetty.server.Server
import org.eclipse.jetty.webapp.WebAppContext
import org.openmole.gate.server.Servlet
import org.scalatra.LifeCycle
import org.scalatra.servlet.ScalatraListener
import server.Launcher.MongoDB

object Launcher extends App {
  case class MongoDB(host: String, port: Int, db: String, dataSet: String)

  val mongoDBArguments = "mongoDBArguments"
  val option = args.headOption
  val mongoURI = new URI(option.getOrElse("mongodb://localhost:27017/openmole?login"))
  println(mongoURI)
  val mongoDB = {
    val host = mongoURI.getHost
    println(host)
    val port = mongoURI.getPort
    println(port)
    println("path=" + mongoURI.getPath)
    val db = mongoURI.getPath.drop(1)
    println("query=" + mongoURI.getQuery)
    val dataSet = mongoURI.getQuery
    //if (mongoURI.getHost== null || mongoURI.getHost.isEmpty) None
    //else Some(MongoDB(host, port, db, dataSet))
    MongoDB(host, port, db, dataSet)
  }
  val server = new Server(8080)
  val context = new WebAppContext()

  context.setAttribute(mongoDBArguments, mongoDB)

  val webapp = getClass.getClassLoader.getResource("webapp").toExternalForm

  context setContextPath "/"
  context.setResourceBase(webapp)
  context.setInitParameter(ScalatraListener.LifeCycleKey, classOf[GateBootstrap].getCanonicalName)
  context.addEventListener(new ScalatraListener)
  server.setHandler(context)

  server.start
  server.join

}

class GateBootstrap extends LifeCycle {
  override def init(context: ServletContext) {
    val mongoDB = context.get(Launcher.mongoDBArguments).get.asInstanceOf[MongoDB]
    context.mount(new Servlet(mongoDB), "/*")
  }
}